import { FieldInfo } from 'model-util-base'
import { ConditionUtil, ConditionUtilImpl, FieldUtil, TableUtilImpl, IdType, JoinTable, SubTable } from 'model-util'
import { Container, Singleton } from 'typescript-ioc' 
import { PresentationBusType } from '../models/index' 
/**
 * @author auto generate
 * @version 1.0
 * @date 2022-11-15 17:47
 */
interface PresentationBusTypeCU extends ConditionUtil<PresentationBusTypeCU>{
    ID:FieldUtil<PresentationBusTypeCU>;
    TEXT:FieldUtil<PresentationBusTypeCU>;
    PARAM:FieldUtil<PresentationBusTypeCU>;
    SORT:FieldUtil<PresentationBusTypeCU>;
}

class PresentationBusTypeCUImpl extends ConditionUtilImpl<PresentationBusTypeCUImpl> implements PresentationBusTypeCU{ 
    newInstance(): PresentationBusTypeCUImpl {
        return new PresentationBusTypeCUImpl();
    } 
    get ID(): FieldUtil<PresentationBusTypeCU>{  
        return new FieldUtil('id','id','主键', this);
    }
    get TEXT(): FieldUtil<PresentationBusTypeCU>{  
        return new FieldUtil('text','text','', this);
    }
    get PARAM(): FieldUtil<PresentationBusTypeCU>{  
        return new FieldUtil('param','param','', this);
    }
    get SORT(): FieldUtil<PresentationBusTypeCU>{  
        return new FieldUtil('sort','sort','', this);
    }
}

@Singleton 
class PresentationBusTypeMU extends TableUtilImpl<PresentationBusTypeCU,PresentationBusType>{ 
    tableName  = 'presentation_bus_type';
    tableFields  = ['id','text','param','sort'];
    modelFields  = ['id','text','param','sort'];
    modelIdFields  = ['id'];
    tableIdFields  = ['id'];
    idType = IdType.CUSTOM;
    joinTables = [];
    subTables = [];

    createConditionUtil(): PresentationBusTypeCU {
        return new PresentationBusTypeCUImpl();
    }   

    static get ID(): FieldUtil<PresentationBusTypeCU>{ 
        return new FieldUtil('id','id','主键', new PresentationBusTypeCUImpl());
    }
    static get TEXT(): FieldUtil<PresentationBusTypeCU>{ 
        return new FieldUtil('text','text','', new PresentationBusTypeCUImpl());
    }
    static get PARAM(): FieldUtil<PresentationBusTypeCU>{ 
        return new FieldUtil('param','param','', new PresentationBusTypeCUImpl());
    }
    static get SORT(): FieldUtil<PresentationBusTypeCU>{ 
        return new FieldUtil('sort','sort','', new PresentationBusTypeCUImpl());
    }

    get ID(): FieldUtil<PresentationBusTypeCU>{ 
        return PresentationBusTypeMU.ID;
    }
    get TEXT(): FieldUtil<PresentationBusTypeCU>{ 
        return PresentationBusTypeMU.TEXT;
    }
    get PARAM(): FieldUtil<PresentationBusTypeCU>{ 
        return PresentationBusTypeMU.PARAM;
    }
    get SORT(): FieldUtil<PresentationBusTypeCU>{ 
        return PresentationBusTypeMU.SORT;
    }
}
export {PresentationBusTypeMU, PresentationBusTypeCU}
